/***************************************************************************
 *   Copyright (C) 2009 by Stanson <stanson@pangolin.ru>                   *
 *   GPL v3 code, read COPYING file                                        *
 *                                                                         *
 * Audi Gamma III LCD serial interface.                                    *
 *                                                                         *
 **************************************************************************/

#include <pic18fregs.h>
#include "main.h"
#include "cd4094.h"
#include "delay.h"

byte cd4094_state;

void cd4094_set( byte d ) __wparam
{
    byte i;

    cd4094_state = d;
    CD4094_CLK = 0;

    for( i = 0; i < 8; i++ )
    {
	if( d & 0x80 ) CD4094_DATA = 1;
	else           CD4094_DATA = 0;
	CD4094_CLK = 1;
	DELAY_uS(1);
	CD4094_CLK = 0;
	DELAY_uS(1);
	d <<= 1;
    }

    CD4094_DATA = 0;

    CD4094_STR = 1;
    DELAY_uS(1);
    CD4094_STR = 0;
    DELAY_uS(1);
}

void cd4094_init( void )
{
    TRISBbits.TRISB0 = 0;
    TRISBbits.TRISB1 = 0;
    TRISAbits.TRISA4 = 0;

    CD4094_STR = 0;
}
