/***************************************************************************
 *   Copyright (C) 2009 by Stanson <stanson@pangolin.ru>                   *
 *   GPL v3 code, read COPYING file                                        *
 **************************************************************************/
#include <pic18fregs.h>
#include "main.h"

byte eeprom_read( byte addr ) __wparam
{
    EECON1 = 0;
    EEADR  = addr;
    EECON1bits.RD = 1;
    return EEDATA;
}

void eeprom_read_data( byte addr, __data byte * d, byte size )
{
    EECON1 = 0;
    EEADR  = addr;
    while( size )
    {
	EECON1bits.RD = 1;
	*d++ = EEDATA;
	EEADR++;
	size--;
    }
}

void eeprom_write( byte addr, byte d )
{
    EECON1 = 0x04;
    EEADR  = addr;
    EEDATA = d;
    INTCONbits.GIE = 0;
    EECON2 = 0x55;
    EECON2 = 0xAA;
    EECON1bits.WR = 1;
    INTCONbits.GIE = 1;
    while(EECON1bits.WR);
    EECON1bits.WREN = 0;
}

void eeprom_write_data( byte addr, __data byte * d, byte size )
{
    EECON1 = 0x04;
    EEADR  = addr;

    while( size )
    {
	EEDATA = *d++;
	INTCONbits.GIE = 0;
	EECON2 = 0x55;
	EECON2 = 0xAA;
	EECON1bits.WR = 1;
	INTCONbits.GIE = 1;
	while(EECON1bits.WR);
	EEADR++;
	size--;
    }

    EECON1bits.WREN = 0;
}
