/***************************************************************************
 *   Copyright (C) 2009 by Stanson <stanson@pangolin.ru>                   *
 *   GPL v3 code, read COPYING file                                        *
 **************************************************************************/

#include <pic18fregs.h>
#include "main.h"
#include "usb.h"
#include "led.h"

byte led_state;	     /*   */
byte led_timer;	     /*   */
byte led_flashes;    /*     */
byte led_next_state; /*       */

void led_init(void)
{
    LED_TRIS       = 0;
    LED_PIN        = 0;
    led_timer      = LED_PERIOD / 2;
    led_state      = LED_STATE_USB;
    led_next_state = LED_STATE_USB;
    led_flashes    = 0;
}

void led_process(void)
{
    led_timer--;

    if(led_state <= LED_STATE_FLASHING)
    {
	if(led_timer == 0)
	{
	    if(led_state != LED_STATE_FLASHING && --led_flashes == 0)
	    { /*   */
		led_state = led_next_state;
	    }
	    else
	    {
		if(LED_PIN) LED_PIN = 0;
		else        LED_PIN = 1;
	    }
	}
    }
    else if(led_state == LED_STATE_USB)
    {
	if(usb_device_state == CONFIGURED_STATE) LED_PIN = 1;
	else                                     LED_PIN = 0;
    }
    else /* LED_STATE_ON or LED_STATE_OFF */
    {
	if(led_state & 1) LED_PIN = 1;
	else              LED_PIN = 0;
    }

    if(led_timer == 0) led_timer = LED_PERIOD / 2;
}

void led_set(byte state) __wparam
{
    if(state <= LED_STATE_FLASHING)
    { /*   */

	if(led_state > LED_STATE_FLASHING)
	{ /*   ,    */
	    led_timer = 1;
	    /*       */
	    led_next_state = led_state;
	}

	if(state < LED_STATE_FLASHING)
	{ /*     */
	    if(state > 64) state = 64;
	    led_flashes = state << 1;
	    led_flashes++;
	}
    }

    led_state = state;
}
