#ifndef _RX_H
#define _RX_H

#define RX_STEREO_PIN		PORTAbits.RA3
#define RX_STEREO_TRIS		TRISAbits.TRISA3
#define RX_STEREO_DEBOUNCE	200 /* 200 mS */

#define RX_DX_PIN		PORTCbits.RC0
#define RX_DX_TRIS		TRISCbits.TRISC0

#define RX_FM_PIN		4
#define RX_BAND_AM		0
#define RX_BAND_FM		1

#define RX_RSSI_PERIOD		200 /* 200 mS */

#define RX_SCAN_PERIOD		200 /* 200 mS */

#define RX_FM_FREQ_MIN		5000 /* 50.00 MHz */
#define RX_FM_FREQ_MAX		15000 /* 150.00 MHz */

#define RX_AM_FREQ_MIN		26960 /* C01R 26.960 MHz */
#define RX_AM_FREQ_MAX		27405 /* C40E 27.405 MHz */

extern void rx_process( void );
extern void rx_init( void );
extern void rx_scan_start( void );
extern void rx_scan_stop( void );
extern void rx_setup( byte fm, word freq );
extern void rx_dx_set( byte dx ) __wparam;
extern void rx_dx_toggle( void );
extern void rx_tune( char step ) __wparam;
extern void rx_save( byte off ) __wparam;
extern void rx_restore( byte off ) __wparam;
extern void rx_set_fm( byte fm ) __wparam;

#endif
